unit Unit1;
  interface
  uses
  SysUtils,
  Classes,Forms;

   type
   Interfase = interface
   ['{FC82C53B-5D2E-40A5-89CC-ECC637DF8E6A}']
      function Description : string; safecall;
      function PlgName:string; safecall;
      function AuthorName:string;safecall;
      function Version:string;safecall;
      procedure  Initialize(obj:TForm);safecall;
      procedure  Dispose();safecall;
   end;

   TInterfase = class (TObject,Interfase)
   public
      function Description : string; safecall;
      function PlgName:string; safecall;
      function AuthorName:string; safecall;
      function Version:string; safecall;
      procedure  Initialize(obj:TForm); safecall;
      procedure  Dispose(); safecall;
      function QueryInterface(const IID: TGUID; out Obj): HResult; stdcall;
     function _AddRef:integer; stdcall;
     function _Release:integer; stdcall;
   end;


   TIPlugin = class of TInterfase;
   function IPlugin: TIPlugin; stdcall; export;


 implementation
    uses Dialogs;

    function IPlugin: TIPlugin; stdcall;
    begin
      Result := TInterfase;
    end;

    function TInterfase.QueryInterface(const IID: TGUID; out Obj): HResult;
    begin
    if GetInterface(IID, Obj) then
       Result := S_OK
    else
       Result := E_NOINTERFACE;
    end;


    function TInterfase._AddRef:integer;
    begin
    end;

    function TInterfase._Release:integer;
    begin
    end;

    function TInterfase.Description : string;
    begin
      Result :='TESSSSSTTT';
    end;

  function TInterfase.PlgName:string;
  begin
    Result :='Canvas painter';
  end;

  function TInterfase.AuthorName:string;
  begin
    Result := 'Avtor name';
  end;


  function TInterfase.Version:string;
  begin
    Result := '2.0.0.0';

  end;


procedure  TInterfase.Initialize(obj:TForm);
begin
showmessage('Hello');
end;

procedure  TInterfase.Dispose();
begin
end;

end.
